DeclareModule CkSCard
CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_DLL
   Declare ckInitGlobal()
CompilerEndIf
  Declare.i ckCreate()
  Declare ckDispose(obj.i)
  Declare.s ckActiveProtocol(obj.i)
  Declare.s ckCardAtr(obj.i)
  Declare.s ckConnectedReader(obj.i)
  Declare.s ckContext(obj.i)
  Declare.s ckDebugLogFilePath(obj.i)
  Declare setCkDebugLogFilePath(obj.i, value.s)
  Declare.s ckLastErrorHtml(obj.i)
  Declare.s ckLastErrorText(obj.i)
  Declare.s ckLastErrorXml(obj.i)
  Declare.l ckLastMethodSuccess(obj.i)
  Declare setCkLastMethodSuccess(obj.i, value.l)
  Declare.s ckPcscLibPath(obj.i)
  Declare setCkPcscLibPath(obj.i, value.s)
  Declare.s ckReaderStatus(obj.i)
  Declare.s ckScardError(obj.i)
  Declare.l ckVerboseLogging(obj.i)
  Declare setCkVerboseLogging(obj.i, value.l)
  Declare.s ckVersion(obj.i)
  Declare.l ckBeginTransaction(obj.i)
  Declare.l ckCheckStatus(obj.i)
  Declare.l ckConnect(obj.i, reader.s, shareMode.s, preferredProtocol.s)
  Declare.l ckDisconnect(obj.i, disposition.s)
  Declare.l ckEndTransaction(obj.i, disposition.s)
  Declare.l ckEstablishContext(obj.i, scope.s)
  Declare.l ckFindSmartcards(obj.i, json.i)
  Declare.l ckGetAttrib(obj.i, attr.s, bd.i)
  Declare.s ckGetAttribStr(obj.i, attr.s)
  Declare.l ckGetAttribUint(obj.i, attr.s)
  Declare.l ckGetStatusChange(obj.i, maxWaitMs.l, stReaderNames.i, json.i)
  Declare.i ckGetStatusChangeAsync(obj.i, maxWaitMs.l, stReaderNames.i, json.i)
  Declare.l ckGetStatusChangeCancel(obj.i)
  Declare.l ckListReaderGroups(obj.i, readerGroups.i)
  Declare.l ckListReaders(obj.i, st.i)
  Declare.l ckReconnect(obj.i, shareMode.s, preferredProtocol.s, action.s)
  Declare.l ckReleaseContext(obj.i)
  Declare.l ckSaveLastError(obj.i, path.s)
  Declare.l ckSendControl(obj.i, controlCode.l, bdSend.i, bdRecv.i)
  Declare.l ckSendControlHex(obj.i, controlCode.l, sendData.s, bdRecv.i)
  Declare.l ckTransmit(obj.i, protocol.s, bdSend.i, bdRecv.i, maxRecvLen.l)
  Declare.l ckTransmitHex(obj.i, protocol.s, apduHex.s, bdRecv.i, maxRecvLen.l)
EndDeclareModule

Module CkSCard
  PrototypeC.i cksPropGet(obj.i)
  PrototypeC.l cklPropGet(obj.i)
  PrototypeC.q ckqPropGet(obj.i)
  PrototypeC cksPropSet(obj.i, value.s)
  PrototypeC cklPropSet(obj.i, value.l)
  PrototypeC ckqPropSet(obj.i, value.q)
  PrototypeC.l cklM(obj.i)
  PrototypeC.l cklMsss(obj.i, arg1.s, arg2.s, arg3.s)
  PrototypeC.l cklMi(obj.i, arg1.i)
  PrototypeC.l cklMlsi(obj.i, arg1.l, arg2.s, arg3.i)
  PrototypeC.i ckiMlii(obj.i, arg1.l, arg2.i, arg3.i)
  PrototypeC.l cklMsi(obj.i, arg1.s, arg2.i)
  PrototypeC.l cklMssil(obj.i, arg1.s, arg2.s, arg3.i, arg4.l)
  PrototypeC.l cklMs(obj.i, arg1.s)
  PrototypeC.l cklMlii(obj.i, arg1.l, arg2.i, arg3.i)
  PrototypeC.l cklMsiil(obj.i, arg1.s, arg2.i, arg3.i, arg4.l)
  PrototypeC.i CkSCardCreate()
  PrototypeC CkSCardDispose(obj.i)

CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_DLL
   Procedure ckInitGlobal()
CompilerEndIf

  CompilerSelect #PB_Compiler_OS
    CompilerCase #PB_OS_Windows
      CompilerIf #PB_Compiler_Processor = #PB_Processor_x86
        CkSCardLibId.i = OpenLibrary(#PB_Any, "chilkatPb32-9_5_0.dll")
      CompilerElse
        CkSCardLibId.i = OpenLibrary(#PB_Any, "chilkatPb-9_5_0.dll")
      CompilerEndIf
    CompilerCase #PB_OS_MacOS
      CompilerIf #PB_Compiler_Processor = #PB_Processor_arm64
        CkSCardLibId.i = OpenLibrary(#PB_Any, "libchilkatPbM1-9_5_0.dylib")
      CompilerElse
        CkSCardLibId.i = OpenLibrary(#PB_Any, "libchilkatPb-9_5_0.dylib")
      CompilerEndIf
    CompilerCase #PB_OS_Linux
      CompilerIf #PB_Compiler_Processor = #PB_Processor_x86
        CkSCardLibId.i = OpenLibrary(#PB_Any, "libchilkatPb32-9_5_0.so")
      CompilerElseIf #PB_Compiler_Processor = #PB_Processor_arm32
        CkSCardLibId.i = OpenLibrary(#PB_Any, "libchilkatPbArm32-9_5_0.so")
      CompilerElseIf #PB_Compiler_Processor = #PB_Processor_arm64
        CkSCardLibId.i = OpenLibrary(#PB_Any, "libchilkatPbArm64-9_5_0.so")
      CompilerElse
        CkSCardLibId.i = OpenLibrary(#PB_Any, "libchilkatPb-9_5_0.so")
      CompilerEndIf
  CompilerEndSelect
  Global SCardCreate.CkSCardCreate = GetFunction(CkSCardLibId,"CkSCardU_CreateW")
  Global SCardDispose.CkSCardDispose = GetFunction(CkSCardLibId,"CkSCardU_DisposeW")
  Global SCardActiveProtocol.cksPropGet = GetFunction(CkSCardLibId,"CkSCardU_activeProtocolW")
  Global SCardCardAtr.cksPropGet = GetFunction(CkSCardLibId,"CkSCardU_cardAtrW")
  Global SCardConnectedReader.cksPropGet = GetFunction(CkSCardLibId,"CkSCardU_connectedReaderW")
  Global SCardContext.cksPropGet = GetFunction(CkSCardLibId,"CkSCardU_contextW")
  Global SCardDebugLogFilePath.cksPropGet = GetFunction(CkSCardLibId,"CkSCardU_debugLogFilePathW")
  Global SCardPSetDebugLogFilePath.cksPropSet = GetFunction(CkSCardLibId,"CkSCardU_putDebugLogFilePathW")
  Global SCardLastErrorHtml.cksPropGet = GetFunction(CkSCardLibId,"CkSCardU_lastErrorHtmlW")
  Global SCardLastErrorText.cksPropGet = GetFunction(CkSCardLibId,"CkSCardU_lastErrorTextW")
  Global SCardLastErrorXml.cksPropGet = GetFunction(CkSCardLibId,"CkSCardU_lastErrorXmlW")
  Global SCardLastMethodSuccess.cklPropGet = GetFunction(CkSCardLibId,"CkSCardU_getLastMethodSuccessW")
  Global SCardPSetLastMethodSuccess.cklPropSet = GetFunction(CkSCardLibId,"CkSCardU_putLastMethodSuccessW")
  Global SCardPcscLibPath.cksPropGet = GetFunction(CkSCardLibId,"CkSCardU_pcscLibPathW")
  Global SCardPSetPcscLibPath.cksPropSet = GetFunction(CkSCardLibId,"CkSCardU_putPcscLibPathW")
  Global SCardReaderStatus.cksPropGet = GetFunction(CkSCardLibId,"CkSCardU_readerStatusW")
  Global SCardScardError.cksPropGet = GetFunction(CkSCardLibId,"CkSCardU_scardErrorW")
  Global SCardVerboseLogging.cklPropGet = GetFunction(CkSCardLibId,"CkSCardU_getVerboseLoggingW")
  Global SCardPSetVerboseLogging.cklPropSet = GetFunction(CkSCardLibId,"CkSCardU_putVerboseLoggingW")
  Global SCardVersion.cksPropGet = GetFunction(CkSCardLibId,"CkSCardU_versionW")
  Global SCardBeginTransaction.cklM = GetFunction(CkSCardLibId,"CkSCardU_BeginTransactionW")
  Global SCardCheckStatus.cklM = GetFunction(CkSCardLibId,"CkSCardU_CheckStatusW")
  Global SCardConnect.cklMsss = GetFunction(CkSCardLibId,"CkSCardU_ConnectW")
  Global SCardDisconnect.cklMs = GetFunction(CkSCardLibId,"CkSCardU_DisconnectW")
  Global SCardEndTransaction.cklMs = GetFunction(CkSCardLibId,"CkSCardU_EndTransactionW")
  Global SCardEstablishContext.cklMs = GetFunction(CkSCardLibId,"CkSCardU_EstablishContextW")
  Global SCardFindSmartcards.cklMi = GetFunction(CkSCardLibId,"CkSCardU_FindSmartcardsW")
  Global SCardGetAttrib.cklMsi = GetFunction(CkSCardLibId,"CkSCardU_GetAttribW")
  Global SCardGetAttribStr.cklMs = GetFunction(CkSCardLibId,"CkSCardU_getAttribStrW")
  Global SCardGetAttribUint.cklMs = GetFunction(CkSCardLibId,"CkSCardU_GetAttribUintW")
  Global SCardGetStatusChange.cklMlii = GetFunction(CkSCardLibId,"CkSCardU_GetStatusChangeW")
  Global SCardGetStatusChangeAsync.ckiMlii = GetFunction(CkSCardLibId,"CkSCardU_GetStatusChangeAsyncW")
  Global SCardGetStatusChangeCancel.cklM = GetFunction(CkSCardLibId,"CkSCardU_GetStatusChangeCancelW")
  Global SCardListReaderGroups.cklMi = GetFunction(CkSCardLibId,"CkSCardU_ListReaderGroupsW")
  Global SCardListReaders.cklMi = GetFunction(CkSCardLibId,"CkSCardU_ListReadersW")
  Global SCardReconnect.cklMsss = GetFunction(CkSCardLibId,"CkSCardU_ReconnectW")
  Global SCardReleaseContext.cklM = GetFunction(CkSCardLibId,"CkSCardU_ReleaseContextW")
  Global SCardSaveLastError.cklMs = GetFunction(CkSCardLibId,"CkSCardU_SaveLastErrorW")
  Global SCardSendControl.cklMlii = GetFunction(CkSCardLibId,"CkSCardU_SendControlW")
  Global SCardSendControlHex.cklMlsi = GetFunction(CkSCardLibId,"CkSCardU_SendControlHexW")
  Global SCardTransmit.cklMsiil = GetFunction(CkSCardLibId,"CkSCardU_TransmitW")
  Global SCardTransmitHex.cklMssil = GetFunction(CkSCardLibId,"CkSCardU_TransmitHexW")
CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_DLL
   EndProcedure
CompilerEndIf

  Procedure.i ckCreate() : ProcedureReturn SCardCreate() : EndProcedure
  Procedure ckDispose(obj.i) : ProcedureReturn SCardDispose(obj) : EndProcedure
  Procedure.s ckActiveProtocol(obj.i) : ProcedureReturn PeekS(SCardActiveProtocol(obj)) : EndProcedure
  Procedure.s ckCardAtr(obj.i) : ProcedureReturn PeekS(SCardCardAtr(obj)) : EndProcedure
  Procedure.s ckConnectedReader(obj.i) : ProcedureReturn PeekS(SCardConnectedReader(obj)) : EndProcedure
  Procedure.s ckContext(obj.i) : ProcedureReturn PeekS(SCardContext(obj)) : EndProcedure
  Procedure.s ckDebugLogFilePath(obj.i) : ProcedureReturn PeekS(SCardDebugLogFilePath(obj)) : EndProcedure
  Procedure setCkDebugLogFilePath(obj.i, value.s) : ProcedureReturn SCardPSetDebugLogFilePath(obj,value) : EndProcedure
  Procedure.s ckLastErrorHtml(obj.i) : ProcedureReturn PeekS(SCardLastErrorHtml(obj)) : EndProcedure
  Procedure.s ckLastErrorText(obj.i) : ProcedureReturn PeekS(SCardLastErrorText(obj)) : EndProcedure
  Procedure.s ckLastErrorXml(obj.i) : ProcedureReturn PeekS(SCardLastErrorXml(obj)) : EndProcedure
  Procedure.l ckLastMethodSuccess(obj.i) : ProcedureReturn SCardLastMethodSuccess(obj) : EndProcedure
  Procedure setCkLastMethodSuccess(obj.i, value.l) : ProcedureReturn SCardPSetLastMethodSuccess(obj,value) : EndProcedure
  Procedure.s ckPcscLibPath(obj.i) : ProcedureReturn PeekS(SCardPcscLibPath(obj)) : EndProcedure
  Procedure setCkPcscLibPath(obj.i, value.s) : ProcedureReturn SCardPSetPcscLibPath(obj,value) : EndProcedure
  Procedure.s ckReaderStatus(obj.i) : ProcedureReturn PeekS(SCardReaderStatus(obj)) : EndProcedure
  Procedure.s ckScardError(obj.i) : ProcedureReturn PeekS(SCardScardError(obj)) : EndProcedure
  Procedure.l ckVerboseLogging(obj.i) : ProcedureReturn SCardVerboseLogging(obj) : EndProcedure
  Procedure setCkVerboseLogging(obj.i, value.l) : ProcedureReturn SCardPSetVerboseLogging(obj,value) : EndProcedure
  Procedure.s ckVersion(obj.i) : ProcedureReturn PeekS(SCardVersion(obj)) : EndProcedure
  Procedure.l ckBeginTransaction(obj.i) :  ProcedureReturn SCardBeginTransaction(obj) :  EndProcedure
  Procedure.l ckCheckStatus(obj.i) :  ProcedureReturn SCardCheckStatus(obj) :  EndProcedure
  Procedure.l ckConnect(obj.i, reader.s, shareMode.s, preferredProtocol.s) :  ProcedureReturn SCardConnect(obj, reader, shareMode, preferredProtocol) :  EndProcedure
  Procedure.l ckDisconnect(obj.i, disposition.s) :  ProcedureReturn SCardDisconnect(obj, disposition) :  EndProcedure
  Procedure.l ckEndTransaction(obj.i, disposition.s) :  ProcedureReturn SCardEndTransaction(obj, disposition) :  EndProcedure
  Procedure.l ckEstablishContext(obj.i, scope.s) :  ProcedureReturn SCardEstablishContext(obj, scope) :  EndProcedure
  Procedure.l ckFindSmartcards(obj.i, json.i) :  ProcedureReturn SCardFindSmartcards(obj, json) :  EndProcedure
  Procedure.l ckGetAttrib(obj.i, attr.s, bd.i) :  ProcedureReturn SCardGetAttrib(obj, attr, bd) :  EndProcedure
  Procedure.s ckGetAttribStr(obj.i, attr.s) :  ProcedureReturn PeekS(SCardGetAttribStr(obj, attr)) :  EndProcedure
  Procedure.l ckGetAttribUint(obj.i, attr.s) :  ProcedureReturn SCardGetAttribUint(obj, attr) :  EndProcedure
  Procedure.l ckGetStatusChange(obj.i, maxWaitMs.l, stReaderNames.i, json.i) :  ProcedureReturn SCardGetStatusChange(obj, maxWaitMs, stReaderNames, json) :  EndProcedure
  Procedure.i ckGetStatusChangeAsync(obj.i, maxWaitMs.l, stReaderNames.i, json.i) :  ProcedureReturn SCardGetStatusChangeAsync(obj, maxWaitMs, stReaderNames, json) :  EndProcedure
  Procedure.l ckGetStatusChangeCancel(obj.i) :  ProcedureReturn SCardGetStatusChangeCancel(obj) :  EndProcedure
  Procedure.l ckListReaderGroups(obj.i, readerGroups.i) :  ProcedureReturn SCardListReaderGroups(obj, readerGroups) :  EndProcedure
  Procedure.l ckListReaders(obj.i, st.i) :  ProcedureReturn SCardListReaders(obj, st) :  EndProcedure
  Procedure.l ckReconnect(obj.i, shareMode.s, preferredProtocol.s, action.s) :  ProcedureReturn SCardReconnect(obj, shareMode, preferredProtocol, action) :  EndProcedure
  Procedure.l ckReleaseContext(obj.i) :  ProcedureReturn SCardReleaseContext(obj) :  EndProcedure
  Procedure.l ckSaveLastError(obj.i, path.s) :  ProcedureReturn SCardSaveLastError(obj, path) :  EndProcedure
  Procedure.l ckSendControl(obj.i, controlCode.l, bdSend.i, bdRecv.i) :  ProcedureReturn SCardSendControl(obj, controlCode, bdSend, bdRecv) :  EndProcedure
  Procedure.l ckSendControlHex(obj.i, controlCode.l, sendData.s, bdRecv.i) :  ProcedureReturn SCardSendControlHex(obj, controlCode, sendData, bdRecv) :  EndProcedure
  Procedure.l ckTransmit(obj.i, protocol.s, bdSend.i, bdRecv.i, maxRecvLen.l) :  ProcedureReturn SCardTransmit(obj, protocol, bdSend, bdRecv, maxRecvLen) :  EndProcedure
  Procedure.l ckTransmitHex(obj.i, protocol.s, apduHex.s, bdRecv.i, maxRecvLen.l) :  ProcedureReturn SCardTransmitHex(obj, protocol, apduHex, bdRecv, maxRecvLen) :  EndProcedure
EndModule

